import { IPromise, Result } from '@pilotlab/result';
import INode from './interfaces/iNode';
import NodeNavigator from './nodeNavigator';
import INodeNavigationTracker from './interfaces/iNodeNavigationTracker';
export declare class NodeNavigationTracker<TNode extends INode> implements INodeNavigationTracker {
    constructor(navigator: NodeNavigator<TNode>, nodeCurrent: TNode, pathDestination: string, pathSegmentDelimiter?: string, forEachParentSegment?: (nodeCurrent: INode, nodeParent: INode) => IPromise<any>, forEachChildSegment?: (nodeCurrent: INode, nodeChild: INode) => IPromise<any>, isUpdateHistory?: boolean);
    update(nodeCurrent: INode, isCompleted?: boolean, isInterrupted?: boolean, isError?: boolean): NodeNavigationTracker<any>;
    start(): void;
    interrupt(): NodeNavigationTracker<TNode>;
    readonly key: string;
    private _key;
    readonly navigator: NodeNavigator<TNode>;
    private _navigator;
    readonly nodeCurrent: TNode;
    private _nodeCurrent;
    readonly pathDestination: string;
    private _pathDestination;
    readonly pathSegmentDelimiter: string;
    private _pathSegmentDelimiter;
    readonly forEachParentSegment: (nodeCurrent: INode, nodeParent: INode) => IPromise<any>;
    private _forEachParentSegment;
    readonly forEachChildSegment: (nodeCurrent: INode, nodeChild: INode) => IPromise<any>;
    private _forEachChildSegment;
    readonly isStarted: boolean;
    private _isStarted;
    readonly isCompleted: boolean;
    private _isCompleted;
    readonly isInterrupted: boolean;
    private _isInterrupted;
    readonly isUpdateHistory: boolean;
    private _isUpdateHistory;
    readonly isError: boolean;
    private _isError;
    next: NodeNavigationTracker<TNode>;
    private _next;
    readonly result: Result<NodeNavigationTracker<TNode>>;
    private _result;
    then(onDone: (value: NodeNavigationTracker<TNode>) => any, onError?: (error: Error) => void): IPromise<any>;
}
export default NodeNavigationTracker;
